package ru.dbotthepony.mc.otm.datagen.advancements

import net.minecraft.advancements.Advancement
import net.minecraftforge.common.data.ExistingFileHelper
import net.minecraftforge.data.event.GatherDataEvent
import java.util.LinkedList
import java.util.function.Consumer

class AdvancementProvider(event: GatherDataEvent) : net.minecraft.data.advancements.AdvancementProvider(event.generator, event.existingFileHelper) {
	private val callbacks = LinkedList<(Consumer<Advancement>, ExistingFileHelper) -> Unit>()

	fun exec(callback: (Consumer<Advancement>, ExistingFileHelper) -> Unit) {
		callbacks.add(callback)
	}

	fun exec(callback: (Consumer<Advancement>) -> Unit) {
		callbacks.add { it, _ ->
			callback.invoke(it)
		}
	}

	override fun registerAdvancements(consumer: Consumer<Advancement>, fileHelper: ExistingFileHelper) {
		for (callback in callbacks) {
			callback.invoke(consumer, fileHelper)
		}
	}
}
